<?php
namespace addons\xhpay\controller;

use addons\xhpay\library\Service;
use think\addons\Controller;
use Exception;

/**
 * 微信支付宝插件首页
 *
 * 此控制器仅用于开发展示说明和体验，建议自行添加一个新的控制器进行处理返回和回调事件，同时删除此控制器文件
 *
 * Class Index
 * @package addons\xhpay\controller
 */
class Index extends Controller
{

    protected $layout = 'default';

    protected $config = [];

    public function _initialize()
    {
        parent::_initialize();
    }

    public function index()
    {
        $this->view->assign("title", "FastAdmin微信支付宝整合插件");
        return $this->view->fetch();
    }

    /**
     * 体验，仅供开发测试
     */
    public function experience()
    {
        $amount = $this->request->request('amount');
        $type = $this->request->request('type');
        $method = $this->request->request('method');

        if (!$amount || $amount < 0) {
            $this->error("支付金额必须大于0");
        }

        if (!$type || !in_array($type, ['alipay', 'wechat'])) {
            $this->error("支付类型不能为空");
        }

        //订单号
        $out_trade_no = date("YmdHis") . mt_rand(100000, 999999);

        //订单标题
        $title = '测试订单';

        //回调链接
        $notifyurl = $this->request->root(true) . '/addons/xhpay/index/notifyx';
        $returnurl = $this->request->root(true) . '/addons/xhpay/index/returnx/out_trade_no/' . $out_trade_no;

        return Service::submitOrder($amount*100, $out_trade_no, $type, $title, $notifyurl, $returnurl, $method);
    }
    
    /**
     * 支付成功，仅供开发测试
     */
    public function notifyx()
    {
        $pay = Service::checkNotify();
        if($pay['status']=='complete'){
        	/************商户业务处理******************/
            //TODO:此处处理订单业务逻辑,支付平台会多次调用本接口(防止网络异常导致回调失败等情况)
            //     请避免订单被二次更新而导致业务异常！！！
            //     if(订单未处理){
            //         处理订单....
            //      }
            /*************商户业务处理 END*****************/
        }else{
        	//处理未支付的情况
        }
        ob_clean();
        print 'success';//支付平台收到“success”表示回调成功。
    }
    
    /**
     * 支付返回，仅供开发测试
     */
    public function returnx()
    {
        //你可以在这里通过out_trade_no去验证订单状态
        //但是不可以在此编写订单逻辑！！！

        $this->success("请返回网站查看支付结果", addon_url("xhpay/index/index"));
    }

}
